zoukankan      html  css  js  c++  java
  • hdu 5073 Galaxy(2014acm鞍山亚洲分部 C)

    主题链接:http://acm.hdu.edu.cn/showproblem.php?

    pid=5073

    Galaxy

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)
    Total Submission(s): 768    Accepted Submission(s): 179
    Special Judge


    Problem Description
    Good news for us: to release the financial pressure, the government started selling galaxies and we can buy them from now on! The first one who bought a galaxy was Tianming Yun and he gave it to Xin Cheng as a present.


    To be fashionable, DRD also bought himself a galaxy. He named it Rho Galaxy. There are n stars in Rho Galaxy, and they have the same weight, namely one unit weight, and a negligible volume. They initially lie in a line rotating around their center of mass.

    Everything runs well except one thing. DRD thinks that the galaxy rotates too slow. As we know, to increase the angular speed with the same angular momentum, we have to decrease the moment of inertia.

    The moment of inertia I of a set of n stars can be calculated with the formula


    where wi is the weight of star i, di is the distance form star i to the mass of center.

    As DRD’s friend, ATM, who bought M78 Galaxy, wants to help him. ATM creates some black holes and white holes so that he can transport stars in a negligible time. After transportation, the n stars will also rotate around their new center of mass. Due to financial pressure, ATM can only transport at most k stars. Since volumes of the stars are negligible, two or more stars can be transported to the same position.

    Now, you are supposed to calculate the minimum moment of inertia after transportation.
     

    Input
    The first line contains an integer T (T ≤ 10), denoting the number of the test cases.

    For each test case, the first line contains two integers, n(1 ≤ n ≤ 50000) and k(0 ≤ k ≤ n), as mentioned above. The next line contains n integers representing the positions of the stars. The absolute values of positions will be no more than 50000.
     

    Output
    For each test case, output one real number in one line representing the minimum moment of inertia. Your answer will be considered correct if and only if its absolute or relative error is less than 1e-9.
     

    Sample Input
    2 3 2 -1 0 1 4 2 -2 -1 1 2
     

    Sample Output
    0 0.5
     

    Source
     

    Recommend
    liuyiding   |   We have carefully selected several similar problems for you:  5081 5080 5079 5077 5076 
     

    Statistic | Submit | Discuss | Note


    #include<iostream>
    #include<cstdio>
    #include<cstring>
    #include<cmath>
    #include<algorithm>
    #define MAXN 50100
    using namespace std;
    int T,N,K;
    int pos[MAXN],sum[MAXN],x[MAXN],First,Last;
    double DL,DR,mass;
    int PL,PR,need;
    double ans,NowI;
    double GetNext(){
        double ret=NowI;
        double pmass=mass;
        mass=(sum[Last+1]-sum[First]+0.0)/need;
        NowI+=-(pmass-pos[First])*(pmass-pos[First])+(mass-pos[Last+1])*(mass-pos[Last+1]);
        NowI+=(mass-pmass)*(mass-pmass)*(need-1);
        DL-=(pmass-pos[First]);
        Last++;First++;
        int t=PL-First+1;
        NowI+=2*DL*(mass-pmass);
        DL+=(mass-pmass)*t;
        PL++;
        while(PL<=N && pos[PL]<=mass){
            DL+=fabs(mass-pos[PL]);
            DR-=fabs(pmass-pos[PL]);
            NowI+=(mass-pos[PL])*(mass-pos[PL]);
            NowI-=(pmass-pos[PL])*(pmass-pos[PL]);
            NowI-=(mass-pmass)*(mass-pmass);
            PL++;
        }
        NowI+=2*(pmass-mass)*DR;
        DR+=(pos[Last]-mass);
        PL--;
        DR-=(mass-pmass)*(Last-(PL+1));
        return NowI;
    }
    int main(){
    //    freopen("in.txt","r",stdin);
        scanf("%d",&T);
        while(T--){
            scanf("%d%d",&N,&K);
            for(int i=0;i<N;i++)
                scanf("%d",&pos[i]);
            sort(pos,pos+N);
            sum[0]=pos[0];
            for(int i=1;i<N;i++)
                sum[i]=sum[i-1]+pos[i];
            need=N-K;ans=0;PL=0;
            if(N==1 || need <2 ){
                puts("0.000000000000");
                continue;
            }
            double kkk=sum[need-1]*1.0/need;First=0;Last=need-1;
            DL=0;PL=0;DR=0;NowI=0;
            for(int i=0;i<need;i++){
                NowI+=(kkk-pos[i])*(kkk-pos[i]);
                if(pos[i]<=kkk){
                    PL=i;
                    DL+=(kkk-pos[i]);
                }
                else
                    DR+=(pos[i]-kkk);
            }
            mass=kkk;
            ans=NowI;
            while(Last<N-1){
                GetNext();
                ans=min(ans,NowI);
            }
            printf("%.12lf
    ",ans);
        }
    }
    
    


  • 相关阅读:
    IDEA使用笔记
    面试题整理
    java中的hashCode()方法
    动态规划算法实现部分——0/1背包问题
    算法课堂笔记6—近似算法
    Photoshop CC 2015
    unity学习笔记1--Space Shooter
    转载---sql之left join、right join、inner join的区别
    java连接Fastdfs图片服务器上传失败的解决方法
    Eclipse使用笔记
  • 原文地址:https://www.cnblogs.com/mfrbuaa/p/5040853.html
Copyright © 2011-2022 走看看